#define SHADOW_DISTANCE_EFFECTIVE 16 // [8 12 16 24 32 40]
#define SHADOW_DISTORTION_AMOUNT_INVERSE (SHADOW_DISTANCE_EFFECTIVE * shadowProjection[0].x)
#define SHADOW_DEPTH_RADIUS 1536.0
#define SHADOW_DEPTH_SCALE (SHADOW_DEPTH_RADIUS / 128.0)

float calculate_distortion_factor(vec2 position) {
	return 1.0 / (SHADOW_DISTORTION_AMOUNT_INVERSE + length(position));
}

vec2 distort_shadowspace(vec2 position) {
	return position * calculate_distortion_factor(position);
}

vec3 distort_shadowspace(vec3 position) {
	position.xy = distort_shadowspace(position.xy);
    position.z *= rcp(SHADOW_DEPTH_SCALE);
	return position;
}

