vec2 encodeNormal(in vec3 normal) {

    normal.xy = normal.xy / dot(abs(normal), vec3(1.0)) + 0.00390625;

    normal.xy = normal.z <= 0.0 ? (1.0 - abs(normal.yx)) * sign(normal.xy) : normal.xy;

    return normal.xy * 0.5 + 0.5;
}

vec3 decodeNormal(in vec2 encodedNormal) {

    vec3 normal = vec3(0.0);

    encodedNormal = encodedNormal * 2.0 - 1.0;

    normal.xy = abs(encodedNormal);

    normal.z = 1.0 - normal.x - normal.y;
    
    normal.xy = (1.0 - normal.yx) * sign(encodedNormal);

    normal.xy = normal.z <= 0.0 ? normal.xy : encodedNormal;

    return normalize(normal.xyz);
}