const vec3 internalScale = vec3((pi / BLADES) * (1.0 - ROUNDING), cos(pi / BLADES), pi * BLADES);

vec2 bokeh_point_map(in float point, const in float piScale, const in float tauScale) {
    return circle_map(point * tauScale + ROTATION) * abs(internalScale.y * tau - pow(abs(cos(point * piScale)), internalScale.x));
}

vec3 bokehImage(float lod, vec2 offset) {
	float r = 0.0;

	vec2 coord = (texture_coordinate - offset) * pow(2.0, lod);

	vec3 size = vec3(0.35);
	     size.x *= (1.0 - 1.0 * LENS_SHIFT_AMOUNT);
	     size.y *= (1.0 - 0.5 * LENS_SHIFT_AMOUNT);

	float softness = 0.9;

    float tauScale = tau * rcp(BLADES);
    float piScale = internalScale.z * rcp(BLADES);

	for (int i = 0; i < BLADES; i++) {
		vec2 bokeh = bokeh_point_map(i, piScale, tauScale);
		r = max(r, dot(coord - 0.5, normalize(bokeh)));
	}

	r = mix(r, distance(coord, vec2(0.5)) * 0.8, camera_f());

	vec3 bokeh;
	bokeh = saturate(1.0 - smoothstep(size * softness, size, vec3(r)));

	return bokeh;
}

vec2 bokeh_shape_coord(float lod, vec2 offset, vec2 coord) {
	float r = 0.0;

	vec2 size = vec2(0.35);

    float tauScale = tau * rcp(BLADES);
    float piScale = internalScale.z * rcp(BLADES);

	for (int i = 0; i < BLADES; i++) {
		vec2 bokeh = bokeh_point_map(i, piScale, tauScale);
		r = max(r, dot(coord - 0.5, normalize(bokeh)));
	}

	r = mix(r, distance(coord, vec2(0.5)) * 0.8, camera_f());

    return saturate(1.0 - smoothstep(size, size, vec2(r)));
}