//This is trying to simulate a camera with a sensor width of 35mm.
const float sensor_width = 35.0 * 1e-3;

//This is used to determine the roundness of the aperture.
float camera_f() {
    #ifdef UseFStopForRounding
        float fstop = FSTOP;
        float fstop_max = 32.0;
        float fstop_min = 1.4;
        return 1.0 - ((fstop - fstop_min) / (fstop_max - fstop_min));
    #else
        return ROUNDING;
    #endif
}

//This calculates the camera aperture size.
float camera_aperture(in float focal) {
    float fstop = FSTOP;
    return (focal / fstop);
}

//This calculates the camera circle of confusion.
float calculate_camera_coc(in float focus, in float depth) {
    //depth = 0.1 / (1.1 - depth);
    float focal = 0.5 * sensor_width * gbufferProjection[0].x;
    float aperture = camera_aperture(focal * 1e3);

    float coc = aperture * focal * abs(focus - depth) / (depth * abs(focus - focal));
    return coc / sensor_width;
}

vec3 thin_film_interferance(float filmThickness, float filmRefractiveIndex, float theta2) {
	const vec3 wavelengths = vec3(750.0, 570.0, 495.0); // should probably be an input

	float opd = 2.0 * filmRefractiveIndex * filmThickness * cos(theta2);

	return 2.0 * abs(cos(opd * pi / wavelengths));
}