float transmitted_scattering_integral_vclouds(float od, const float coeff) {
	const float a = -1.0 / coeff;

	return od * a - a; // = ∫{0,od} e^(-coeff*x) dx
}

float transmitted_scattering_integral(float od, const float coeff) {
	const float a = -coeff / log(2.0);
	const float b = -1.0 / coeff;
	const float c =  1.0 / coeff;

	return exp2(a * od) * b + c; // = ∫{0,od} e^(-coeff*x) dx
}

vec3 transmitted_scattering_integral(float od, const vec3 coeff) {
	const vec3 a = -coeff / log(2.0);
	const vec3 b = -1.0 / coeff;
	const vec3 c =  1.0 / coeff;

	return exp2(a * od) * b + c; // = ∫{0,od} e^(-coeff*x) dx
}