#ifndef MC_GL_RENDERER_RADEON
    layout(location = 0) out vec4 out_color;
    layout(location = 1) out vec4 out_data;
    layout(location = 2) out vec4 out_extra;
    layout(location = 3) out vec4 out_albedo;
#endif

#include "/lib/important.glsl"
#include "/lib/encoders/encoder.glsl"

//Samplers
uniform sampler2D gcolor;

//Uniforms
/* Nothing to see here */

//Fragment inputs
flat in vec3 tint;
in vec2 lightmap_coordinate;

#ifdef MC_GL_RENDERER_RADEON
    vec4 out_color;
    vec4 out_data;
    vec4 out_extra;
    vec4 out_albedo;
#endif

/* DRAWBUFFERS:0256 */
void main() {
    out_color.rgb = tint;
    out_color.a = 0.5;

    out_data.r = 0.0;
    out_data.g = 0.0;
    out_data.b = encode2x8(lightmap_coordinate);
    out_data.a = 0.0;

    out_extra.r = 0.0;
    out_extra.g = 0.0;
    out_extra.b = 0.0;
	out_extra.a = 0.0;

    #ifdef MC_GL_RENDERER_RADEON
        gl_FragData[0] = out_color;
        gl_FragData[1] = out_data;
        gl_FragData[2] = out_extra;
        gl_FragData[3] = out_albedo;
    #endif
}