#ifndef MC_GL_RENDERER_RADEON
    layout(location = 0) out vec4 out_color;
    layout(location = 1) out vec4 out_data;
    layout(location = 2) out vec4 out_extra;
#endif

#include "/lib/important.glsl"
#include "/lib/encoders/encoder.glsl"

//Samplers
uniform sampler2D gcolor;
uniform sampler2D specular;

//Uniforms
uniform float frameTimeCounter;

//Fragment inputs
in vec3 tint;
in vec3 flat_normal;
in vec2 texture_coordinate;
in vec2 lightmap_coordinate;
flat in float id;

#ifdef MC_GL_RENDERER_RADEON
    vec4 out_color;
    vec4 out_data;
    vec4 out_extra;
#endif

/* DRAWBUFFERS:025 */
void main() {
    out_color.rgb = texture(gcolor, fract(texture_coordinate + (frameTimeCounter * 0.3))).rgb * tint;
    out_color.rgb += texture(gcolor, fract(texture_coordinate + (frameTimeCounter * 1.5))).rgb * tint;
    out_color.rgb += texture(gcolor, fract(texture_coordinate - (frameTimeCounter * 1.5))).rgb * tint;
    out_color.rgb += texture(gcolor, fract(texture_coordinate - (frameTimeCounter * 0.3))).rgb * tint;
    out_color.rgb /= 4.0;
    if(texture(gcolor, texture_coordinate).a < 0.01) discard;
    out_color.a = 1.0;

    out_data.r = 0.0;
    out_data.g = 0.0; //This will be used for something...eventually.
    out_data.b = 0.0;
    out_data.a = id / 65535.0;

    out_extra.r = encode2x8(encodeNormal(flat_normal));
    out_extra.g = 0.0;
    out_extra.b = 0.0;
	out_extra.a = 0.0;

    #ifdef MC_GL_RENDERER_RADEON
        gl_FragData[0] = out_color;
        gl_FragData[1] = out_data;
        gl_FragData[2] = out_extra;
    #endif
}