layout(location = 0) out vec3 bloom;

#include "/lib/important.glsl"

//Samplers
uniform sampler2D colortex3;

//Uniforms
uniform vec2 view_size, view_pixel_size;

uniform float viewHeight;

//Fragment inputs
in vec2 texture_coordinate;

const float[5] weights = float[5](0.19947114, 0.29701803, 0.09175428, 0.01098007, 0.00050326);
const float[5] offsets = float[5](0.00000000, 1.40733340, 3.29421497, 5.20181322, 7.13296424);

/* DRAWBUFFERS:3 */
void main() {
	bloom = texture(colortex3, texture_coordinate).rgb * weights[0];

	for (int i = 1; i < 5; i++) {
		vec2 offset = offsets[i] * vec2(0.0, 1.0 / viewHeight);
		bloom += texture(colortex3, texture_coordinate + offset).rgb * weights[i];
		bloom += texture(colortex3, texture_coordinate - offset).rgb * weights[i];
	}

	bloom *= MaxColorRange;
}