/* DRAWBUFFERS:3 */
layout(location = 0) out vec3 out_sky;

const bool colortex0Clear = false;
const bool colortex1Clear = false;
const bool colortex2Clear = false;
const bool colortex3Clear = false;
const bool colortex4Clear = false;
const bool colortex5Clear = false;
const bool colortex6Clear = false;
const bool colortex7Clear = false;

#include "/lib/important.glsl"

//Samplers
/* Nothing to see here */

//Uniforms
uniform mat4 gbufferModelViewInverse, gbufferProjectionInverse;
uniform mat4 gbufferModelView, gbufferProjection;

uniform vec3 sun_vector, moon_vector, up_vector;

uniform vec2 view_size, view_pixel_size;

uniform float rainStrength, eyeAltitude;

//Fragment inputs
in vec2 texture_coordinate;

#include "/lib/sky/atmos_projection.glsl"
#include "/lib/color/blackbody_functions.glsl"
#include "/lib/color/light_colors.glsl"
#include "/lib/sky/atmosphere/calculate.glsl"

vec3 multi() {
    vec3 ret = atmos(normalize(vec3(0, 1, 0)), vec3(0.0), coefficients_scattering, coefficients_extinction);

    return ret / pi;
}

void main() {
    if(texture_coordinate.y >= exp2(-SKY_RENDER_LOD) || texture_coordinate.x >= exp2(-SKY_RENDER_LOD)) discard;
    #if World == 0
        #ifdef Atmos_Analytical
            out_sky = atmos_analytical(unproject_sky(texture_coordinate), atmos_analytical(vec3(0, 1, 0), vec3(0.0), coefficients_analytical), coefficients_analytical);
        #else
            out_sky = atmos(unproject_sky(texture_coordinate), multi(), coefficients_scattering, coefficients_extinction);
        #endif
    #elif World == 1
        out_sky = vec3(1.5, 0.5, 0.1) / 15.0;
    #endif
}