#version 420

#ifndef MC_GL_RENDERER_RADEON
    layout(location = 0) out vec4 out_color;
    layout(location = 1) out vec4 out_data;
#endif

#include "/lib/important.glsl"
#include "/lib/encoders/encoder.glsl"

//Samplers
uniform sampler2D gcolor;

//Uniforms
/* Nothing to see here */

//Fragment inputs
in vec3 tint;
in vec3 shadow_normal;
in vec2 texture_coordinate;
in float skylight;
flat in float id;

#ifdef MC_GL_RENDERER_RADEON
    vec4 out_color;
    vec4 out_data;
#endif

float is_foliage = 0.0;

/* DRAWBUFFERS:01 */
void main() {
    out_color = texture(gcolor, texture_coordinate) * vec4(tint, 1.0);

    float water = 0.0;
    if(id == 8.0 || id == 9.0) {
        out_color = vec4(1.0);
        water = 1.0;
    }
    bool grass = false;
    bool leaves = false;
    if(id == 6.0 || id == 31.0 || id == 32.0 || id == 37.0 || id == 38.0 || id == 59.0 || id == 175.0) grass = true;
    if(id == 18.0 || id == 106.0 || id == 111.0 || id == 161.0) leaves = true;

    if(grass || leaves) {
        is_foliage = 1.0;
    }

    out_data.rg = encodeNormal(shadow_normal) * 0.5 + 0.5;
    out_data.b = skylight;
    out_data.a = is_foliage;

    #ifdef MC_GL_RENDERER_RADEON
        gl_FragData[0] = out_color;
        gl_FragData[1] = out_data;
    #endif
}